
/* Update the cert database and write a log record */

static int update_db(X509 *crt, char *byid)
{
  int crtdb = open(CA_CERTDB, O_CREAT|O_WRONLY, 0660);
  CertRec C = (CertRec) malloc(sizeof(CertRec_));
  int sn;
  int nb;
  char *dn;
  FILE *log;
  time_t now = time(NULL);
  struct tm *t = localtime(&now);

  if (!crtdb) return (0);
 
  memset(C, '\0', sizeof(CertRec_));

  sn = i2i_ASN1_INTEGER(crt->cert_info->serialNumber);
  C->casn = sn;
  C->issue_date = ASN1_UTCTIME_get(X509_get_notBefore(crt));
  C->expire_date = ASN1_UTCTIME_get(X509_get_notAfter(crt));
  C->revoke_date = 0;
  dn = X509_NAME_oneline(X509_get_subject_name(crt),NULL,0);
  dn[239] = '\0';
  strcpy(C->dn, dn);
  
  if (lseek(crtdb, sn*sizeof(CertRec_), SEEK_SET)>0) {
     nb = write(crtdb, C, sizeof(CertRec_));
  }
  close(crtdb);
  free (C);

  /* write log */

  log = fopen(CA_LOG,"a");
  if (log) {
     fprintf(log,"%4d/%02d/%02d %02d:%02d:%02d %6d signed by %s: %s \n",
           t->tm_year+1900, t->tm_mon+1, t->tm_mday,
           t->tm_hour, t->tm_min, t->tm_sec,
           sn, byid, dn);
     fclose(log);
  }

  free(dn);

  return (nb);
}


