/* CA cert to browser installer */

#include <stdio.h>
#include <time.h>

#include "webtpl.h"
#include "util.h"

extern char *remote_user;
extern int errno;

#define REQ(s) (req && !strcmp(req,s))

static char *capem = "/usr/local/ca/services/certs/cacert.pem";
static char *cader = "/usr/local/ca/services/certs/cacert.der";

main()
{
  WebTemplate W = newWebTemplate();
  char *userid;
  char *req;
  char *seqstr;
  int seq = 0;
  char *xseq;
  int s;
  char *doc_root = "";

  WebTemplate_get_by_name(W, "page", "page.tpl");
  WebTemplate_get_by_name(W, "indextop", "index_top.tpl");
  WebTemplate_get_by_name(W, "indexbody", "index_body.tpl");

  menu_init(W);
  menu_set(W, "SVPEMPAGE");

  /* Get arguments */

  WebTemplate_get_args(W);

  userid = remote_user;
  seqstr = WebTemplate_get_arg(W, "seq");
  if (seqstr) seq = atoi(seqstr);
  req = WebTemplate_get_arg(W, "req");
  xseq = WebTemplate_get_arg(W, "xseq");

  WebTemplate_assign(W, "TITLE",
        "University of Washington Certificate Authority");
  WebTemplate_assign(W, "CURPAGE", "UW Services CA loader");
  WebTemplate_assign(W, "XSEQ", xsec_gen_token(userid));
  WebTemplate_assign(W, "ROOT", doc_root);



  /* rest of page depends on request */

  /* Request is to do the install */

  if (REQ("caload")) {

     Browser B = get_browser();

     if (xsec_chk_token(NULL, xseq)) {
        WebTemplate_assign(W, "BODY", 
           "<p>Got a sequence error<p>Should you be here?<p>");

     /* IE browser */
     } else if (B->type == BR_IE) {
        FILE *f;
        int l;
        char *pkcs;
        char *p;
        char *r;
        WebTemplate_get_by_name(W, "iehead", "iehead.tpl");
        WebTemplate_get_by_name(W, "iebody", "iebody.tpl");
        WebTemplate_get_by_name(W, "ieload", "ieload.tpl");
        /* read and setup the pkcs7 string */
        f = fopen("/usr/local/ca/services/certs/cacert.pkcs7","r");
        pkcs = (char*) malloc(10240);
        p = pkcs;
        for (;;) { 
          *p++ = '"';
          r = fgets(p, 128, f);
          if (!r) break;
          while (*p && *p!='\n') p++;
          strcpy(p, "\" & _\n");
          p += 6;
          *p = '\0';
        }
        p -= 6;
        *p = '\0';
        WebTemplate_assign(W, "PKCS7CERT", pkcs);
        WebTemplate_parse(W, "HEADTXT", "iehead");
        WebTemplate_parse(W, "BODYTXT", "iebody");
        WebTemplate_assign(W, "RETURN", "/");
        WebTemplate_parse(W, "BODY", "ieload");

        
     /* All others */
     } else {
        
        Browser B = get_browser(); 
        char *c;
        char *crt;
        int l;

        /* send a special page with the cert */
        printf("Content-Type: application/x-x509-ca-cert\n\n");
        fflush(NULL);
        if (B->type == BR_NS || B->type == BR_GECKO) c = capem;
        else c = cader;
        crt = get_file(c, &l);
        write(1, crt, l);
        exit (0);
     }

  /* show the form to install the cacert into a browser */

  } else {

     Browser B = get_browser(); 

     char *helper = NULL;

     if (B->type == BR_NS) helper = "help.ns.html";
     else if (B->type == BR_IE) helper = "help.ie.html";
     else if (B->type == BR_OPERA) helper = "help.opera.html";
     else if (B->type == BR_GECKO) helper = "help.gecko.html";

     if (helper) {
        WebTemplate_assign(W, "HELPER", helper);
        WebTemplate_parse_dynamic(W, "indextop.help");
     }

     WebTemplate_assign(W, "XSEQ", xsec_gen_token(userid));
     WebTemplate_parse(W, "TOPBODY", "indextop");
     WebTemplate_parse(W, "BODY", "indexbody");

  }

  WebTemplate_parse(W, "PAGE", "page");
  WebTemplate_header(W);
  WebTemplate_write(W, "PAGE");

  exit (0);

}

