
<h3>Using the Certificate Revocation List (CRL)</h3>

<p>

The CRL identifies those certificates that the UW CA
has determined are no longer valid and has revoked.
Use of a CRL is not necessary, but does enhance the
security of your client or service. 

<p>

Specific use depends on your application. 
PEM format is convenient
because you can copy the text from your browser
and paste it into an application or file. The CRL in  DER format  
contains unprintable characters and does not lend itself  
to the copy and paste method.
Many applications can,
however, work more easily with the DER format.

<p>
In addition, certificates issued by the CA contain CRL
distribution point information.  Someday soon software
products will automatically make use of that information -
thereby obviating the manual distribution method.


<p>

<b>Browsers</b>
<p>
 <ul>
    <li>You can click on the <i>DER format</i> link and
        load the CRL into most browsers.
    <li>Be advised however that the CRL will have to be
        reloaded when it expires, or else your browser
        will not accept our certificates.
 </ul>
<p>
<b>Apache web servers</b>
<p>
<ul>
  <li>A Web server does not need the CRL unless it will
        be authenticating clients (e.g. SOAP enabled programs)
        who themselves use our CA's certificates.
  <li>
        Each brand of web server has specific configuration 
        instructions to indicate CRL information.
        For Apache with mod_ssl some applicable directives are 
        <p>
        <tt>
        <ul>
        <li>SSLCARevocationPath 
        <li>SSLCARevocationFile 
        </ul>
        </tt>
        <p>
  <li>See the <a href=http://www.modssl.org/docs/>mod_ssl</a>
        documentation.
 </ul>
<p>

<b>Programs unsing the OpenSSL library</b>
<p>
 <ul>
 <li>OpenSSL does not automatically check for certificate revocation.
     You have to do that by hand in the verifier callback.
 <li>We at present have no example.
 <li>You could reference the mod_ssl example.
</ul>

<p>

<b>MS Windows applications</b>
<p>
 <ul>
 <li>Windows applications will find the DER format
        of the CRL the most convenient.
 <li>Click on the <i>DER format</i> link to allow your
     system's certificate manager to install the list.
 </ul>
<p>




