
<h3>Installing the root certificate</h3>

<p>

The CA's root certificate must be installed into any 
program that will be connecting to an application
that authenticates itself with our (the UW CA) certificates.

<p>

Specific use depends on your application.  PEM is convenient
because you can copy and paste the text from your browser
into an application or file.  DER is not printable and 
therefore cannot be as easily copied.  Many applications can,
however, work more easily with the DER format.

<p>

<b>Browsers</b>
<p>
 <ul>
    <li>The installation button on our 
          <a href="http://www.washington.edu/computing/ca/">
          user documentation</a> page provides the easiest means
          to load the root certififcate into a browser.
 </ul>
<p>
<b>Apache web servers</b>
<p>
<ul>
  <li>A Web server does not need access to the CA's root unless
        it will be authenticating clients (e.g. SOAP enabled programs)
        who themselves use our CA's certificates.
  <li>
        Each brand of web server has specific configuration 
        instructions to indicate trusted root certificates.
        For Apache some applicable directives are 
        <p>
        <tt>
        <ul>
        <li>SSLVerifyClient
        <li>SSLCACertificatePath 
        <li>SSLCACertificateFile 
        <li>SSLVerifyDepth 
        </ul>
        </tt>
        <p>
  <li>See the <a href=http://httpd.apache.org/docs/>Apache</a>
        documentation.
 </ul>
<p>

<b>Programs unsing the OpenSSL library</b>
<p>
 <ul>
 <li>OpenSSL is the most popular open source SSL library.
 <li>Paste the certificate into a file, e.g. <tt>cacert.pem</tt>.
 <li>Configure your program to use this file, using, for example,
        this function
    <br>
     <tt>
      <ul>
     <li>SSL_CTX_load_verify_locations
      </ul>
      </tt>
 <li>See the <a href=http://www.openssl.org/>OpenSSL</a>
        documentation.
</ul>

<p>

<b>MS Windows applications</b>
<p>
 <ul>
 <li>Windows applications will find the DER format
        of the root certificate the most convenient.
 <li>Click on the <i>DER format</i> link to allow your
     system's certificate manager to install the certificate.
 <li>The most appropriate storage area for the certificate on
        your system may depend on the particular application.
 </ul>
<p>




