/* C&C CA client-server definitions */

#ifndef CA_H 
#define CA_H

#include <arpa/inet.h>


/* Command is header plus text */

#define CA_ID_LEN 16
#define CA_KPW_LEN 256

typedef struct CmdHdr__ {
  uint32_t cmd;        /* command */
  uint32_t ext;        /* extension code */
  uint32_t flags;      /* flags */
  char id[CA_ID_LEN];     /* id of signer */
  char kpw[CA_KPW_LEN];    /* ca key password */
  uint32_t len;        /* length of text */
} CmdHdr_, *CmdHdr;

/* commands */
#define CA_SIGN    1
#define CA_REVOKE  2
#define CA_GENCRL  3
#define CA_GETCRL  4
#define CA_PKCS7   5

/* extensions */
#define CA_EXT_DEF 0
#define CA_EXT_SV  1
#define CA_EXT_CL  2
#define CA_EXT_SC  3
#define CA_EXT_COD 4

/* flags ( bitmap) */ 
#define CA_FL_ALTNAMDNS  1  /* use request altname dns entries */


/* Response is header plus text */

typedef struct RspHdr__ {
  uint32_t rsp;        /* response code */
  uint32_t len;        /* length of text */
} RspHdr_, *RspHdr;




#define CA_MAXARG  16384
#define CA_MAXCRL  1024*1024

#define CA_PORT    "447"
#define CA_HOST    "uwca03.s.uw.edu"

/* cert cns */
#define CL_CN      "UWCA Client"
#define SV_CN      "UWCA Server"


#endif /* CA_H */
