/* CA utility: id-domain ownership reconciliation.

   */


#include <stdio.h>
#include <signal.h>
#include <string.h>

#include "webtpl.h"

#include "db.h"
#include "util.h"
#include "cassl.h"
#include "ca.h"


extern int errno;

char *prog;
usage()
{
   fprintf(stderr, "usage: %s [-r reqno] [-h hostname]\n");
   exit (1);
}

main(int argc, char **argv)
{
  char *user;
  int s;
  char *p;
  SvrReq R = (SvrReq) malloc(sizeof(SvrReq_));
  int rc;
  char smsg[24];
  char *dn = NULL;
  int reqno = 0;

  prog = argv[0];
  while (--argc>0) {
     argv++;
     if (!strcmp(argv[0],"-r")) {
        if (--argc<=0) usage();
        reqno = atoi((++argv)[0]);
        printf("Recon for reqno %d\n", reqno);

     } else if (!strcmp(argv[0],"-h")) {
        if (--argc<=0) usage();
        dn = (++argv)[0];
        printf("Recon for host %s\n", dn);

     } else usage();
  }

  db_connect();

  db_select_req(reqno, dn, NULL, RST_ALIVE, NULL);

  while (db_get_req(R)>0) {

    if (R->status==ST_REVREQ) continue;

    db_update_owners(R);

  }
}

