/* CA utility provider: domain name help */

#include <stdio.h>
#include <signal.h>
#include <string.h>

#include "webtpl.h"
#include "util.h"
#include "cassl.h"

extern char *remote_user;
extern int errno;
char *errstr = NULL;


/* handle client disconnect */

void catch_pipe(int a)
{
   signal(SIGPIPE, catch_pipe);
}


char **netact_get_host_ids(char *name);
char **netact_get_domain_ids(char *name);

main()
{
  WebTemplate W = newWebTemplate();
  char *userid;
  char *req;
  char *seqstr;
  int seq = 0;
  int s;
  char *xseq;
  char *doc_root = "";
  char *dn;
  char **list;
  char *dp, *edp;
  int nsd = 0;
  char *pname;
  int nl;
 
  signal(SIGPIPE, catch_pipe);

  WebTemplate_set_comments(W, "#", NULL);
  WebTemplate_get_by_name(W, "page", "page.tpl");
  WebTemplate_get_by_name(W, "dn", "dnhelp.tpl");

  if ((xseq=getenv("HTTP_HOST"))&&!strstr(xseq,"certs.cac")) doc_root="/cadev";

  /* Get arguments */

  WebTemplate_get_args(W);

  userid = remote_user;

  WebTemplate_assign(W, "TITLE", 
       "University of Washington Certificate Authority");
  WebTemplate_assign(W, "XSEQ", xsec_gen_token(userid));
  WebTemplate_assign(W, "ROOT", doc_root);
  WebTemplate_assign(W, "RUID", remote_user);

  dn = WebTemplate_get_arg(W, "dn");
  fix_dns_name(dn);
  WebTemplate_assign(W, "DN", dn);

  crumb_init(W);
  add_crumb(W, "services/?req=form", "Cert request");

  if (dn && *dn) {
  
     pname = (char*) malloc(strlen(dn)+32);
     sprintf(pname, "Domain: %s", dn);
     WebTemplate_assign(W, "PAGETITLE", pname);

     /* Check for valid domain name */

     if (ssl_chk_dns(dn,0)) {
        WebTemplate_parse_dynamic(W, "dn.nodns");

     /* Check netops */

     } else if (netact_test_name(dn, remote_user)) {
        WebTemplate_parse_dynamic(W, "dn.ok");

 
     /* Show who's got what */

     } else {

        WebTemplate_assign(W, "SDN", dn);
        list = netact_get_host_ids(dn);
        if (list && *list) {
           nl = 0;
           while (*list) {
              WebTemplate_assign(W, "ID", *list);
              WebTemplate_parse_dynamic(W, "dn.notok.host.owners.id");
              list++;
              nl++;
           }
           if (nl==1) WebTemplate_parse_dynamic(W, "dn.notok.host.owners.one");
           else WebTemplate_parse_dynamic(W, "dn.notok.host.owners.many");
           WebTemplate_parse_dynamic(W, "dn.notok.host.owners");
        } else WebTemplate_parse_dynamic(W, "dn.notok.host.noowner");
        WebTemplate_parse_dynamic(W, "dn.notok.host");
    

        /* Show subdomains */
   
        if (edp=strstr(dn,".washington.edu")) {
           for (dp=strchr(dn,'.');dp&&dp<edp;dp=strchr(dp+1,'.')) {
             nsd = 0;
             WebTemplate_assign(W, "SDN", dp+1);
             list = netact_get_domain_ids(dp+1);
             if (list && *list) {
               nl = 0;
               while (*list) {
                 WebTemplate_assign(W, "ID", *list);
                 WebTemplate_parse_dynamic(W, "dn.notok.domain.owners.id");
                 list++;
                 nsd++;
                 nl++;
               }
               if (nl==1) WebTemplate_parse_dynamic(W,
                              "dn.notok.domain.owners.one");
               else WebTemplate_parse_dynamic(W, "dn.notok.domain.owners.many");
               WebTemplate_parse_dynamic(W, "dn.notok.domain.owners");
             } else WebTemplate_parse_dynamic(W, "dn.notok.domain.noowner");
             WebTemplate_parse_dynamic(W, "dn.notok.domain");
           }
        }
        WebTemplate_parse_dynamic(W, "dn.notok");
     }
  }
           
  WebTemplate_parse(W, "BODY", "dn");
  WebTemplate_parse(W, "PAGE", "page");
  WebTemplate_write(W, "PAGE");

}

