
<!-- form for msie cert request -->


<SCRIPT type="text/vbscript">

 ' Option Explicit

Function MakeKeyFlags(keysize)
  Dim flags
  ' If CRYPT_EXPORTABLE is set, the generated private key can be exported 
  ' from IE in passphrase protected pkcs12 envelope.
  ' If CRYPT_USER_PROTECTED is set, the user is allowed to select security
  ' level for the generated private key. If not set the lowest security
  ' level is set as default. This means that private key is not protected
  ' on local disk and user is not prompted is the key is used to sign data.
  Const CRYPT_EXPORTABLE = 1
  Const CRYPT_USER_PROTECTED = 2
  If document.certform.protectkey.checked = true Then
    flags = CRYPT_EXPORTABLE Or CRYPT_USER_PROTECTED
  Else
    flags = CRYPT_EXPORTABLE 
  End If
  MakeKeyFlags = flags Or ( keysize * 65536)
End Function


Function CreatePKCS10Request(keysize, cn)
  Const AT_KEYEXCHANGE = 1
  Const AT_SIGNATURE = 2
  dn = "C=US,ST=WA,O=University of Washington,CN="  & cn
  If document.certform.storetype.value = "local-machine" Then
    xenroll.RequestStoreFlags = &H20000
    document.requestData.storeflags.value = "&H20000"
  Else
    xenroll.RequestStoreFlags = &H10000
    document.requestData.storeflags.value = "&H10000"
  End If
  xenroll.GenKeyFlags = MakeKeyFlags(keysize)
  xenroll.KeySpec = AT_KEYEXCHANGE
  xenroll.EnableT61DNEncoding=True
  CreatePKCS10Request = xenroll.createPKCS10(dn, "")
End Function


sub CertRequestSub
  Dim keysize
  Dim cn
  Dim dn
  Dim notes
  keysize = document.certform.keysize.value
  cn = document.certform.cn.value
  document.requestData.reqtxt.value = CreatePKCS10Request(keysize, cn)
  ' MsgBox("Req: "  & document.requestData.reqtxt.value)
  document.requestData.action.value = "submit"
  document.requestData.reqkeysize.value = keysize
  document.requestData.submit()
end sub



'-----------------------------------------------------------------
' Get the list of CSPs from xenroll
' returns error number
' the list box is 'document.certform.lbCSP'

Function GetCSPList()
  On Error Resume Next
  Dim nProvType, nOrigProvType, nTotCSPs, nDefaultCSP, bNoDssBase, bNoDssDh, sUserAgent
  ' should be >= the number of providers defined in wincrypt.h (~line 431)
  Const nMaxProvType=25 
  nTotCSPs=0
  nDefaultCSP=-1

  sUserAgent=navigator.userAgent
  If CInt(Mid(sUserAgent, InStr(sUserAgent, "MSIE")+5, 1))<=4 Then
    bNoDssDh=True
    bNoDssBase=True
  Else
    bNoDssDh=False
    If 0<>InStr(sUserAgent, "95") Then
      bNoDssBase=True
    ' NT 4 does not include version num in string.
    ElseIf 0<>InStr(sUserAgent, "NT)") Then 
      bNoDssBase=True
    Else
      bNoDssBase=False
    End If
  End If

  ' save the original provider type
  nOrigProvType=xenroll.ProviderType
  If 0 <> Err.Number Then
    ' something wrong with xenroll
    GetCSPList=Err.Number 
    Exit Function
  End If

  ' enumerate through each of the provider types
  For nProvType=0 To nMaxProvType 
    Dim nCSPIndex
    nCSPIndex=0
    xenroll.ProviderType=nProvType
			
    ' enumerate through each of the providers for this type
    Do 
      Dim sProviderName
      'get the name
      sProviderName=xenroll.enumProviders(nCSPIndex, 0)
				
      If &H80070103=Err.Number Then 
        ' no more providers
        Err.Clear
        Exit Do
      ElseIf 0<>Err.Number Then
        ' something wrong with xenroll
        '  - ex, Win16 IE4 xenroll doesn't support this call.
        GetCSPList=Err.Number 
        Exit Function
      End If
    
      If ("Microsoft Base DSS Cryptographic Provider"=sProviderName And True=bNoDssBase) _
        Or ("Microsoft Base DSS and Diffie-Hellman Cryptographic Provider"=sProviderName And True=bNoDssDh) Then
        ' skip this provider
      Else 
        ' For each provider, add an element to the list box.
        Dim oOption
        Set oOption=document.createElement("Option")
        oOption.text=sProviderName
        oOption.Value=nProvType
        document.certform.lbCSP.add(oOption)
        If InStr(sProviderName, "Microsoft Enhanced Cryptographic Provider") <> 0 Then
    	  oOption.selected=True
	  nDefaultCSP=nTotCSPs
        End If
	nTotCSPs=nTotCSPs+1
      End If
				
      ' get the next provider
      nCSPIndex=nCSPIndex+1
    Loop
  Next
		
  ' if there are no CSPs, we're kinda stuck
  If 0=nTotCSPs Then
    Set oElement=document.createElement("Option")
    oElement.text="-- No CSP's found --"
    document.certform.lbCSP.Options.Add(oElement)
  End If

  ' remove the 'loading' text
  document.certform.lbCSP.remove(0)

  ' select the default provider
  If -1 <> nDefaultCSP Then
    document.certform.lbCSP.selectedIndex=nDefaultCSP
  End If

  ' restore the original provider type
  xenroll.ProviderType=nOrigProvType

  ' set the return value and exit
  If 0 <> Err.Number Then
    GetCSPList=Err.Number
    ElseIf 0 = nTotCSPs Then
    ' signal no elements with -1
    GetCSPList=-1
  Else
    GetCSPList=0
  End If
End Function
// end GetCSPList


Function postLoad()
  On Error Resume Next   
  Dim nResult  
  nResult = 0
  ' get the CSP list
  nResult = GetCSPList()
  if 0 <> nResult Then
    Exit Function
  end if
  handleCSPChange()
End Function


Function handleCSPChange()
    Dim g_bOkToSubmit, nCSPIndex, nProvType, nSupportedKeyUsages
    Dim keymax, keymin

    ' IE is not ready until xenroll has been loaded
    g_bOkToSubmit = false

    ' some constants defined in wincrypt.h:
    Const CRYPT_EXPORTABLE = 1
    Const CRYPT_USER_PROTECTED = 2
    Const CRYPT_MACHINE_KEYSET = &H20
    Const AT_KEYEXCHANGE = 1
    Const AT_SIGNATURE = 2
    Const CERT_SYSTEM_STORE_LOCAL_MACHINE = &H20000
    Const ALG_CLASS_ANY = 0
    Const ALG_CLASS_SIGNATURE = &H2000
    Const ALG_CLASS_HASH = &H4000
    Const PROV_DSS=3
    Const PROV_DSS_DH=13

    ' convenience constants, for readability
    Const KEY_LEN_MIN=true
    Const KEY_LEN_MAX=false
    Const KEY_USAGE_EXCH=0
    Const KEY_USAGE_SIG=1
    Const KEY_USAGE_BOTH=2

    ' defaults
    Const KEY_LEN_MIN_DEFAULT=384
    Const KEY_LEN_MAX_DEFAULT=16384

    nCSPIndex = document.certform.lbCSP.selectedIndex
    xenroll.ProviderName = document.certform.lbCSP.options(nCSPIndex).text
    nProvType = document.certform.lbCSP.options(nCSPIndex).value
    xenroll.ProviderType = nProvType
    


    nSupportedKeyUsages = AT_KEYEXCHANGE



    if (PROV_DSS = nProvType OR PROV_DSS_DH = nProvType) then
     nSupportedKeyUsages = AT_SIGNATURE
    end if

    document.certform.keyusage.value="both"


End Function

Function ActivateSubmit()

  document.certform.request.disabled = false 

End Function

</SCRIPT>




<!-- Start of visible page -->



<!-- This is the form that actually get submitted -->

<form name="requestData" action="{ROOT}/services/" method=post>

<input type="hidden" name="reqtxt">
<input type="hidden" name="action" value="">
<input type="hidden" name="reqkeysize" value="">
<input type="hidden" name="storeflags" value="">
  <input type=hidden name=xsite value={XSITE}>
  <input type=hidden name=xtime value={XTIME}>
<input type="hidden" name="xseq" value="{XSEQ}">
<input type="hidden" name="f1" value="{F1}">
<input type="hidden" name="req" value="sub">
<input type="hidden" name="form4ms" value="yes">

</form>


<!-- this visible form is processed by "CertRequestSub" -->

<form name="certform">

If you are unsure of a choice, accept the default.
<p>

Choose a cryptographic provider
<br>
<select name="lbCSP" onchange="handleCSPChange()" language="VBSCRIPT"> 
<option id=locLoading selected>Loading...
</select>

<!-- Do this if want to allow key size selection --
  Key size:
  <select name=keysize>
  <option value=512> 512
  <option value=1024 selected> 1024
  <option value=2048> 2048
  </select>
  bits.
 -->
<input type=hidden name=keysize value=1024>

<input type=hidden name=keyusage value="signature">
<input type="hidden" name="storeflags" value="">

<!--  do this if want to allow selection of store type --
  Certificate store type: 
  <select name=storetype>
  <option value="current-user"> current user
  <option value="local-machine"> local machine (for Windows IPSec and L2TP)
  </select>
  <p>
 -->
<input type=hidden name=storetype value="local-machine">


<p> 
<input type="hidden" name="protectkey" value="" >

#<p> 
#<input type="checkbox" name="protectkey" value="protectkey" checked>
#Allow key security options
# <br> 
# Deactivated alternate DN scheme
# <input type="checkbox" name="edscert" value="edscert">
# Create EDS client certificate

<p>

Enter your host's fully qualified domain name (CN)
<br>
<input type="textfield" name=cn size=40 value="{DN}"
    onfocus="javascript:document.certform.request.disabled=false;">
<p>

<p>
<input type="button" name="request" value="Generate the request"
       onClick="CertRequestSub" language="VBSCRIPT" 
       border=0 {DISD}>

</form>


